'use strict';

exports.__esModule = true;
exports.extractCritical = extractCritical;

var _index = require('./index');

function extractCritical(html) {
  // parse out ids from html
  // reconstruct css/rules/cache to pass
  var o = { html: html, ids: [], css: '', rules: [] };
  var regex = /css-([a-zA-Z0-9]+)/gm;
  var match = void 0;
  var ids = {};
  while ((match = regex.exec(html)) !== null) {
    if (!ids[match[1] + '']) {
      ids[match[1] + ''] = true;
    }
  }

  o.rules = _index.sheet.sheet.cssRules.filter(function (x) {
    var regex = /css-([a-zA-Z0-9]+)/gm;
    var match = regex.exec(x.cssText);
    if (match && ids[match[1] + '']) {
      return true;
    }
    if (!match) {
      return true;
    }
    return false;
  });
  o.ids = Object.keys(_index.inserted).filter(function (id) {
    return !!ids[id + ''];
  });
  o.css = o.rules.map(function (x) {
    return x.cssText;
  }).join('');

  return o;
}